﻿Imports System.Runtime.InteropServices
Public Class Form1

    Dim current As Process = Process.GetCurrentProcess()
    Dim processes As Process() = Process.GetProcesses
    Dim now As String
    Dim num As Integer
    Dim ht As Integer = My.Computer.Screen.WorkingArea.Height
    Dim wt As Integer = My.Computer.Screen.WorkingArea.Width
    Dim a As Integer
    Dim c As Integer
    Dim i As Integer
    Dim label1 As New Label

    Private Sub Clock_HelpButtonClicked(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.HelpButtonClicked
        MessageBox.Show("Single-click text to dock to desktop. Repeat this to switch back to draggable mode.", "Help", MessageBoxButtons.OK, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
    End Sub

    Public Sub Process_Collect()
        ListBox1.Items.Clear()
        ListBox2.Items.Clear()
        Dim current As Process = Process.GetCurrentProcess()
        Dim processes As Process() = Process.GetProcesses
        Dim ThisProcess As Process
        For Each ThisProcess In processes
            '-- Ignore the current process
            If ThisProcess.Id <> current.Id Then
                '-- Only list processes that have a Main Window Title
                If ThisProcess.MainWindowTitle <> "" Then
                    Dim ProcessFile = FileVersionInfo.GetVersionInfo(ThisProcess.MainModule.FileName)
                    ListBox1.Items.Add(ProcessFile.FileDescription.ToString)
                    ListBox2.Items.Add(ThisProcess.Id)
                End If
            End If
        Next
        For f As Integer = Me.Controls.Count - 1 To 0 Step -1
            Dim ctrl = Me.Controls(f)
            If TypeOf (ctrl) Is Label Then
                ctrl.Dispose()
            End If
        Next
        If ListBox1.Items.Count <> 0 Then
            For Each Item In ListBox1.Items
                Dim label1 As New Label
                Me.Controls.Add(label1)
                label1.Location = New Point(a, 12)
                label1.Font = New Font("Century Gothic", 18, FontStyle.Regular)
                label1.FlatStyle = FlatStyle.Standard
                label1.ForeColor = Color.FromArgb(70, 70, 70)
                label1.Enabled = True
                label1.Visible = True
                label1.Location = New Point(a, 12)
                label1.AutoSize = True
                AddHandler label1.Click, AddressOf ClickLabel
                AddHandler label1.DoubleClick, AddressOf DoubleClickLabel
                Dim namestr As String = Item.ToString
                If namestr.Contains("Microsoft") Then
                    label1.Text = namestr.Substring(9).ToLower
                ElseIf namestr.Contains("Windows") Then
                    label1.Text = namestr.Substring(8).ToLower
                Else
                    label1.Text = namestr.ToLower
                End If
                label1.Tag = ListBox2.Items.Item(ListBox1.Items.IndexOf(Item))
                c = c + label1.Width
                a = c + 10
            Next
        End If
        Me.Width = c + 10
        Me.Location = New Point((wt / 2) - (Me.Width / 2), (ht - 25) - (Me.Height / 2))
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load, Timer1.Tick
        Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
        Me.ControlBox = False
        TransparencyKey = BackColor
        a = 2
        c = 0
        Me.Controls.Remove(label1)
        Process_Collect()
    End Sub

    Private Sub ClickLabel(ByVal sender As Object, ByVal e As EventArgs)
        Dim lbl As Label = CType(sender, Label)
        Dim id As Integer = lbl.Tag
        Dim current As Process = Process.GetCurrentProcess()
        AppActivate(id)
        FocusWindow(id)
    End Sub
    Private Sub DoubleClickLabel()
        End
    End Sub
End Class

